rules:
  - id: glappsec_redos_1
    languages: 
      - ruby
    mode: taint
    pattern-sources:
      - patterns:
          - pattern-either:
              - pattern: |
                  params[...]
              - pattern: |
                  request.env[...]
    pattern-sinks:
      - patterns:
          - pattern-either:
              - patterns:
                  - pattern: $Y
                  - pattern-inside: |
                      /...#{...}.../
              - patterns:
                  - pattern: $Y
                  - pattern-inside: |
                      Regexp.new(...)
    message: >
      Found a potentially user-controllable argument in the construction of a 
      regular expressions. This may result in excessive resource consumption 
      when applied to certain inputs, or when the user is allowed to control the 
      match target. Avoid allowing users to specify regular expressions 
      processed by the server. Refer to https://docs.gitlab.com/ee/development/secure_coding_guidelines.html#denial-of-service-redos--catastrophic-backtracking 
      for more information.
    metadata:
      vulnerability_class: "Denial of Service (ReDoS) / Catastrophic Backtracking"
      technology:
        - ruby
        - rails
      confidence: HIGH
    severity: ERROR
